<script lang="ts">
export default {
  name: 'DibCopyBlock',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      showMore: false,
    };
  },
};
</script>

<template>
  <section class="dib-copy-block">
    <SlpContainer>
      <SlpRow
        class="dib-copy-block__row"
        :class="{ 'dib-copy-block__row--reverse': data.reverse }"
      >
        <SlpColumn :cols="6" class="dib-copy-block__col">
          <div v-if="data.header" class="dib-copy-block__gradient-header"></div>
          <SlpTypography
            v-if="data.header"
            variant="heading2-bold"
            tag="h3"
            class="dib-copy-block__header slp-mb-32"
            >{{ data.header }}</SlpTypography
          >
          <SlpTypography
            v-if="data.sub_header"
            variant="heading4-bold"
            tag="h4"
            class="slp-mb-32"
            >{{ data.sub_header }}</SlpTypography
          >
          <SlpTypography
            v-if="data.highlight"
            variant="heading5-bold"
            tag="h5"
            class="slp-mb-32"
            >{{ data.highlight }}</SlpTypography
          >
          <SlpTypography
            v-if="data.author?.name"
            variant="body1"
            tag="div"
            class="slp-mb-16"
          >
            <SlpMarkdown :text="data.text" class="dib-copy-block__content" />
            <div v-if="data.readMore?.text" class="slp-mt-32">
              <SlpButton
                v-if="!showMore"
                class="dib-copy-block__button"
                variant="tertiary"
                @click.native="showMore = !showMore"
                >{{ data.readMore.button_text }}
                <SlpIcon icon="gl-plus" class="slp-ml-8" />
              </SlpButton>

              <Transition name="block-fade">
                <div v-if="showMore">
                  <SlpMarkdown :text="data.readMore.text" />
                  <SlpButton
                    class="dib-copy-block__button"
                    variant="tertiary"
                    @click.native="showMore = !showMore"
                    >{{ data.readMore.button_text_open }}
                    <SlpIcon icon="gl-dash" class="slp-ml-8" />
                  </SlpButton>
                </div>
              </Transition>
            </div>
          </SlpTypography>
          <SlpTypography
            v-if="data.author?.name"
            variant="body1-bold"
            tag="p"
            >{{ data.author.name }}</SlpTypography
          >
          <SlpTypography v-if="data.author?.role" variant="body1" tag="p">{{
            data.author.role
          }}</SlpTypography>
        </SlpColumn>
        <SlpColumn
          :cols="6"
          class="dib-copy-block__col dib-copy-block__img-col"
        >
          <div class="dib-copy-block__img-container">
            <img
              v-if="data.image?.src"
              :src="data.image.src"
              :alt="data.image.alt"
              class="dib-copy-block__img"
            />
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.dib-copy-block {
  margin-bottom: $spacing-96;
  @media (min-width: $breakpoint-md) {
    margin-bottom: $spacing-96;
    padding-bottom: $spacing-32;
  }

  &__img-col {
    display: flex;
    position: relative;
  }
  &__img {
    position: relative;
    z-index: 1;
    width: 100%;
    margin: 0 auto;
    object-fit: contain;
    max-width: fit-content;
    margin-top: 32px;
    @media (min-width: $breakpoint-md) {
      margin-top: 0;
      margin-bottom: auto;
    }
    @media (min-width: $breakpoint-lg) {
      width: auto;
    }
  }
  &__img-container {
    position: relative;
    pointer-events: none;
    &:before {
      content: '';
      position: absolute;
      height: 0;
      width: 160%;
      width: 118%;
      padding-bottom: 117.5%;
      border: 1px solid $color-surface-700;
      border-radius: 561px;
      opacity: 0.20000000298023224;
      background: radial-gradient(
        50% 50% at 50% 50%,
        #fca326 0%,
        rgba(169, 137, 245, 0) 100%
      );
      z-index: 0;
      top: 10%;
      left: 33%;
    }
    &:after {
      content: '';
      position: absolute;
      height: 0;
      width: 100%;
      padding-bottom: 99.7%;
      border-radius: 100%;
      border: 1px solid $color-secondary-100;
      border-radius: 685px;

      opacity: 0.20000000298023224;
      background: radial-gradient(
        50% 50% at 50% 50%,
        #a989f5 0%,
        rgba(169, 137, 245, 0) 100%
      );

      z-index: 0;

      width: 144%;
      padding-bottom: 143.5%;
      top: 23%;
      left: 60%;
    }
  }
  :deep .markdown-body {
    background: transparent;
  }
  &__row {
    &--reverse {
      flex-direction: row-reverse;
      .dib-copy-block__img-container {
        &:before {
          top: -30%;
          left: -70%;
          width: 160%;
          padding-bottom: 159.5%;
        }
        &:after {
          width: 196%;
          padding-bottom: 195.5%;
          top: -12%;
          left: -41%;
        }
        img {
          @media (min-width: $breakpoint-lg) {
            margin-left: 0;
          }
        }
      }
    }
  }
  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }
  &__button {
    color: $color-text-link-100;
    text-decoration: underline;
    :deep .slp-icon div {
      position: relative;
      svg {
        position: absolute;
        left: 0;
        top: 0;
      }
    }
    &:hover,
    &:focus {
      text-decoration-color: $color-text-link-100;
    }
  }
  .block-fade-enter-active {
    transition: all 0.5s;
  }

  .block-fade-leave-active {
    transition: all 0.3s ease-in;
  }

  .block-fade-enter,
  .block-fade-leave-to {
    transform: translateY(20px);
    opacity: 0;
    @media (prefers-reduced-motion) {
      opacity: 1;
      transform: none;
    }
  }
  .block-fade-leave,
  .block-fade-enter-to {
    opacity: 1;
  }
  &__content {
    :deep h3 {
      font-size: 24px;
      font-weight: 600;
      letter-spacing: -0.6px;
      line-height: 32px;
      margin-bottom: 32px;
    }
  }
}
</style>
